
import { createRouter, createWebHistory } from 'vue-router'
import HomeView from '@/views/HomeView.vue'
import LoginView from '@/views/LoginView.vue'
import NotFoundView from '@/views/NotFoundView.vue'
import AktifIndividual from '@/components/Pages/DaftarTransaksi/AktifIndividual.vue'
import EmptyPage from '@/components/Pages/HomeEmpty.vue'
import { useAuthStore } from '@/stores/auth'
const router = createRouter({
  history: createWebHistory(import.meta.env.BASE_URL),
  linkActiveClass: 'active',
  routes: [
    {
      path: '/home',
      name: 'Home',
      'meta': { requiresAuth: true },
      component: HomeView,
      children: [
        {
          path: '',
          name: 'Home Page',
          component: EmptyPage,
        },
        {
          path: 'gangguan',
          name: 'Gangguan',
          children: [
            {
              path: '1',
              name: 'Daftar',
              children: [
                {
                  path: '1',
                  name: 'Daftar Keluhan Dialihkan Ke Posko Lain',
                  component: EmptyPage,
                },
                {
                  path: '2',
                  name: 'Daftar Gangguan Melapor Lebih Dari 1 Kali',
                  component: EmptyPage,
                },
                {
                  path: '3',
                  name: 'Daftar Gangguan Response Time',
                  component: EmptyPage,
                },
                {
                  path: '4',
                  name: 'Daftar Gangguan Recovery Time',
                  component: EmptyPage,
                },
                {
                  path: '5',
                  name: 'Daftar Gangguan Selesai Tanpa ID Pelanggan',
                  component: EmptyPage,
                },
                {
                  path: '6',
                  name: 'Daftar Gangguan Berdasarkan Media',
                  component: EmptyPage,
                },
                {
                  path: '7',
                  name: 'Daftar Gangguan Diselesaikan Mobile APKT',
                  component: EmptyPage,
                },
              ],
            },
            {
              path: '2',
              name: 'Rekapitulasi',
              children: [
                {
                  path: '1',
                  name: 'Rekapitulasi Gangguan All',
                  component: EmptyPage,
                },
                {
                  path: '2',
                  name: 'Rekapitulasi Gangguan Per Jenis Gangguan',
                  component: EmptyPage,
                },
                {
                  path: '3',
                  name: 'Rekapitulasi Gangguan Per Jenis Gangguan SE 004',
                  component: EmptyPage,
                },
                {
                  path: '4',
                  name: 'Rekapitulasi Gangguan Per Posko',
                  component: EmptyPage,
                },
                {
                  path: '5',
                  name: 'Rekapitulasi Gangguan Per Regu',
                  component: EmptyPage,
                },
                {
                  path: '6',
                  name: 'Rekapitulasi Gangguan Per Tanggal',
                  component: EmptyPage,
                },
                {
                  path: '7',
                  name: 'Rekapitulasi Gangguan Berdasarkan Media',
                  component: EmptyPage,
                },
                {
                  path: '8',
                  name: 'Rekapitulasi Gangguan Alih  Posko',
                  component: EmptyPage,
                },
                {
                  path: '9',
                  name: 'Rekapitulasi Gangguan Per Status',
                  component: EmptyPage,
                },
                {
                  path: '10',
                  name: 'Rekapitulasi Gangguan Diselesaikan Mobile APKT',
                  component: EmptyPage,
                },
                {
                  path: '11',
                  name: 'Rekapitulasi Rating Per Posko',
                  component: EmptyPage,
                },
                {
                  path: '12',
                  name: 'Rekapitulasi Rating Per Regu',
                  component: EmptyPage,
                },
                {
                  path: '13',
                  name: 'Rekapitulasi Koreksi Transaksi Individual',
                  component: EmptyPage,
                },
                {
                  path: '14',
                  name: 'Rekapitulasi Cleansing Transaksi TM',
                  component: EmptyPage,
                },
              ],
            }
          ]
        },
      ]
    },
    {
      path: '/login',
      name: 'Login',
      component: LoginView
    },
    {
      path: '/404',
      name: 'Not Found',
      component: NotFoundView
    },
  ]
})

router.beforeEach((to, from, next) => {
  // redirect to login page if not logged in and trying to access a restricted page
  const auth = useAuthStore();

  // if to is not found, redirect to 404
  if (to.matched.length === 0) {
    if (to.path === '/') {
      if (auth.isLoggedIn) {
        next('/home')
      } else {
        next('/login')
      }
    } else {
      next('/404')
    }
  } else {
    // if to is not login and user is not logged in, redirect to login
    if (auth.isLoggedIn) {
      // if to is login and user is logged in, redirect to home
      if (to.path === '/login') {
        next('/home')
      } else {
        next()
      }
    } else {
      // if to is 404, redirect to 404
      if (to.path !== '/404' && to.path !== '/login') {
        next('/login')
      } else {
        next()
      }
    }
  }

})

export default router
